// DlgGPRSSetup.cpp : implementation file
//

#include "stdafx.h"
#include "TrackDemo.h"
#include "DlgGPRSSetup.h"


// CDlgGPRSSetup dialog

IMPLEMENT_DYNAMIC(CDlgGPRSSetup, CDialog)

CDlgGPRSSetup::CDlgGPRSSetup(CWnd* pParent /*=NULL*/)
  : CDialog(CDlgGPRSSetup::IDD, pParent)
  , m_lai(0)
  , m_username(_T(""))
  , m_password(_T(""))
  , m_apn(_T(""))
  , m_ip(0)
  , m_subnet(0)
  , m_gateway(0)
  , m_dns1(0)
  , m_dns2(0)
  , m_Index(0)
{
}

CDlgGPRSSetup::~CDlgGPRSSetup()
{
}

void CDlgGPRSSetup::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TAB, c_Tab);
  DDX_Text(pDX, IDC_LAI, m_lai);
  DDX_Text(pDX, IDC_USERNAME, m_username);
  DDX_Text(pDX, IDC_PASSWORD, m_password);
  DDX_Text(pDX, IDC_APN, m_apn);
  DDX_IPAddress(pDX, IDC_IP, m_ip);
  DDX_IPAddress(pDX, IDC_SUBNET, m_subnet);
  DDX_IPAddress(pDX, IDC_GATEWAY, m_gateway);
  DDX_IPAddress(pDX, IDC_DNS1, m_dns1);
  DDX_IPAddress(pDX, IDC_DNS2, m_dns2);
}


BEGIN_MESSAGE_MAP(CDlgGPRSSetup, CDialog)
  ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, &CDlgGPRSSetup::OnTcnSelchangeTab)
END_MESSAGE_MAP()


// CDlgGPRSSetup message handlers

BOOL CDlgGPRSSetup::OnInitDialog()
{
	// Default dialog init
  CDialog::OnInitDialog();

  // Controls
  ((CEdit*)GetDlgItem(IDC_LAI))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_USERNAME))->LimitText(33);
  ((CEdit*)GetDlgItem(IDC_PASSWORD))->LimitText(33);
  ((CEdit*)GetDlgItem(IDC_APN))->LimitText(33);

  // Tab control
  c_Tab.InsertItem(0, _T("Entry1"));
  c_Tab.InsertItem(1, _T("Entry2"));
  c_Tab.InsertItem(2, _T("Entry3"));
  c_Tab.InsertItem(3, _T("Entry4"));
  c_Tab.InsertItem(4, _T("Entry5"));

  // Retreive saved values from registry
  m_Entry[0].APN      = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry1.apn"),      _T("internet"));
  m_Entry[0].DNS1     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.dns1"),     0);
  m_Entry[0].DNS2     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.dns2"),     0);
  m_Entry[0].Gateway  = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.gateway"),  0);
  m_Entry[0].IP       = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.ip"),       0);
  m_Entry[0].LAI      = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.lai"),      23801);
  m_Entry[0].Password = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry1.password"), _T(""));
  m_Entry[0].Subnet   = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry1.subnet"),   0);
  m_Entry[0].Username = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry1.username"), _T(""));
  m_Entry[1].APN      = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry2.apn"),      _T("internet"));
  m_Entry[1].DNS1     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.dns1"),     0);
  m_Entry[1].DNS2     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.dns2"),     0);
  m_Entry[1].Gateway  = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.gateway"),  0);
  m_Entry[1].IP       = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.ip"),       0);
  m_Entry[1].LAI      = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.lai"),      23802);
  m_Entry[1].Password = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry2.password"), _T(""));
  m_Entry[1].Subnet   = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry2.subnet"),   0);
  m_Entry[1].Username = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry2.username"), _T(""));
  m_Entry[2].APN      = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry3.apn"),      _T("www.internet.mtelia.dk"));
  m_Entry[2].DNS1     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.dns1"),     0);
  m_Entry[2].DNS2     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.dns2"),     0);
  m_Entry[2].Gateway  = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.gateway"),  0);
  m_Entry[2].IP       = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.ip"),       0);
  m_Entry[2].LAI      = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.lai"),      23820);
  m_Entry[2].Password = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry3.password"), _T(""));
  m_Entry[2].Subnet   = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry3.subnet"),   0);
  m_Entry[2].Username = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry3.username"), _T(""));
  m_Entry[3].APN      = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry4.apn"),      _T("www.internet.mtelia.dk"));
  m_Entry[3].DNS1     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.dns1"),     0);
  m_Entry[3].DNS2     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.dns2"),     0);
  m_Entry[3].Gateway  = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.gateway"),  0);
  m_Entry[3].IP       = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.ip"),       0);
  m_Entry[3].LAI      = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.lai"),      23830);
  m_Entry[3].Password = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry4.password"), _T(""));
  m_Entry[3].Subnet   = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry4.subnet"),   0);
  m_Entry[3].Username = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry4.username"), _T(""));
  m_Entry[4].APN      = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry5.apn"),      _T(""));
  m_Entry[4].DNS1     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.dns1"),     0);
  m_Entry[4].DNS2     = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.dns2"),     0);
  m_Entry[4].Gateway  = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.gateway"),  0);
  m_Entry[4].IP       = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.ip"),       0);
  m_Entry[4].LAI      = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.lai"),      0);
  m_Entry[4].Password = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry5.password"), _T(""));
  m_Entry[4].Subnet   = AfxGetApp()->GetProfileInt(   _T("Access"), _T("Entry5.subnet"),   0);
  m_Entry[4].Username = AfxGetApp()->GetProfileString(_T("Access"), _T("Entry5.username"), _T(""));
  VarToView(0);

  return TRUE;
}

void CDlgGPRSSetup::OnOK()
{
  // Var
  CString EntName;

  // Save old
  ViewToVar(m_Index);

  // Update Registry
  EntName.Format(_T("Entry%d."), m_Index + 1);
  AfxGetApp()->WriteProfileString(_T("Access"), EntName + _T("apn"),      m_Entry[m_Index].APN);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("dns1"),     m_Entry[m_Index].DNS1);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("dns2"),     m_Entry[m_Index].DNS2);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("gateway"),  m_Entry[m_Index].Gateway);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("ip"),       m_Entry[m_Index].IP);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("lai"),      m_Entry[m_Index].LAI);
  AfxGetApp()->WriteProfileString(_T("Access"), EntName + _T("password"), m_Entry[m_Index].Password);
  AfxGetApp()->WriteProfileInt(   _T("Access"), EntName + _T("subnet"),   m_Entry[m_Index].Subnet);
  AfxGetApp()->WriteProfileString(_T("Access"), EntName + _T("username"), m_Entry[m_Index].Username);

  // Default
  CDialog::OnOK();
}

void CDlgGPRSSetup::OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult)
{
  // Result
  *pResult = 0;

  // Save old
  ViewToVar(m_Index);

  // Insert new
  m_Index = c_Tab.GetCurSel();
  VarToView(m_Index);
}

void CDlgGPRSSetup::ViewToVar(const int tab)
{
  // Retreive
  UpdateData(TRUE);

  // Insert in struct
  m_Entry[tab].APN      = m_apn;
  m_Entry[tab].DNS1     = m_dns1;
  m_Entry[tab].DNS2     = m_dns2;
  m_Entry[tab].Gateway  = m_gateway;
  m_Entry[tab].IP       = m_ip;
  m_Entry[tab].LAI      = m_lai;
  m_Entry[tab].Password = m_password;
  m_Entry[tab].Subnet   = m_subnet;
  m_Entry[tab].Username = m_username;
}

void CDlgGPRSSetup::VarToView(const int tab)
{
  // Insert from struct
  m_apn       = m_Entry[tab].APN;
  m_dns1      = m_Entry[tab].DNS1;
  m_dns1      = m_Entry[tab].DNS2;
  m_gateway   = m_Entry[tab].Gateway;
  m_ip        = m_Entry[tab].IP;
  m_lai       = m_Entry[tab].LAI;
  m_password  = m_Entry[tab].Password;
  m_subnet    = m_Entry[tab].Subnet;
  m_username  = m_Entry[tab].Username;

  // Update dialog
  UpdateData(FALSE);
}
