// DlgGatewaySetup.cpp : implementation file
//

#include "stdafx.h"
#include "TrackDemo.h"
#include "DlgGatewaySetup.h"


// CDlgGatewaySetup dialog

IMPLEMENT_DYNAMIC(CDlgGatewaySetup, CDialog)

CDlgGatewaySetup::CDlgGatewaySetup(CWnd* pParent /*=NULL*/)
  : CDialog(CDlgGatewaySetup::IDD, pParent)
  , m_enable(FALSE)
  , m_ip(_T(""))
  , m_port(0)
  , m_key(_T(""))
  , m_maxconn(0)
  , m_retries(0)
  , m_timeout(0)
  , m_alive(0)
{
}

CDlgGatewaySetup::~CDlgGatewaySetup()
{
}

void CDlgGatewaySetup::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_ENABLE, m_enable);
  DDX_Text(pDX, IDC_IPADDR, m_ip);
  DDV_MaxChars(pDX, m_ip, 32);
  DDX_Text(pDX, IDC_IPPORT, m_port);
  DDV_MinMaxInt(pDX, m_port, 1, 65535);
  DDX_Text(pDX, IDC_KEY, m_key);
  DDX_Text(pDX, IDC_MAXCONN, m_maxconn);
  DDV_MinMaxInt(pDX, m_retries, 1, 60);
  DDX_Text(pDX, IDC_SENDRETRY, m_retries);
  DDV_MinMaxInt(pDX, m_retries, 1, 60);
  DDX_Text(pDX, IDC_TIMEOUT, m_timeout);
  DDV_MinMaxInt(pDX, m_timeout, 5, 60);
  DDX_Text(pDX, IDC_ALIVE, m_alive);
  DDV_MinMaxInt(pDX, m_alive, 0, 60000);
}


BEGIN_MESSAGE_MAP(CDlgGatewaySetup, CDialog)
END_MESSAGE_MAP()


// CDlgGatewaySetup message handlers

BOOL CDlgGatewaySetup::OnInitDialog()
{
  // Default
  CDialog::OnInitDialog();

  // Controls
  ((CEdit*)GetDlgItem(IDC_IPADDR))->LimitText(32);
  ((CEdit*)GetDlgItem(IDC_IPPORT))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_KEY))->LimitText(8);
  ((CEdit*)GetDlgItem(IDC_MAXCONN))->LimitText(2);
  ((CEdit*)GetDlgItem(IDC_SENDRETRY))->LimitText(2);
  ((CEdit*)GetDlgItem(IDC_TIMEOUT))->LimitText(2);
  ((CEdit*)GetDlgItem(IDC_ALIVE))->LimitText(5);
  ((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_PORT))->SetRange32(1, 65535);
  ((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_CONN))->SetRange(1, 60);
  ((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_RETRIES))->SetRange(1, 60);
  ((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_TIMEOUT))->SetRange(5, 60);
  ((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_ALIVE))->SetRange32(0, 60000);

  // Retreive saved values from registry
  m_alive   = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("Alive"),    300);
  m_enable  = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("gwEnable"), 1);
  m_ip      = AfxGetApp()->GetProfileString(_T("Gateway"), _T("gwIP"),     _T("gw.rtcu.dk"));
  m_key     = AfxGetApp()->GetProfileString(_T("Gateway"), _T("gwKey"),    _T("AABBCCDD"));
  m_maxconn = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("mnoca"),    3);
  m_port    = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("gwPort"),   5001);
  m_retries = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("mnosra"),   5);
  m_timeout = AfxGetApp()->GetProfileInt(   _T("Gateway"), _T("timeout"),  45);
  UpdateData(FALSE);

  // Completed
  return TRUE;
}

void CDlgGatewaySetup::OnOK()
{
  // Update variables
  if (!UpdateData(TRUE)) return;

  // Update Registry
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("Alive"),    m_alive);
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("gwEnable"), m_enable);
  AfxGetApp()->WriteProfileString(_T("Gateway"), _T("gwIP"),     m_ip);
  AfxGetApp()->WriteProfileString(_T("Gateway"), _T("gwKey"),    m_key);
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("mnoca"),    m_maxconn);
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("gwPort"),   m_port);
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("mnosra"),   m_retries);
  AfxGetApp()->WriteProfileInt(   _T("Gateway"), _T("timeout"),  m_timeout);

  // Default
  CDialog::OnOK();
}
